From: Arnaud Giersch <arnaud.giersch@univ-fcomte.fr>
Date: Mon, 19 Jul 2021 10:42:38 +0200
Subject: Fix crashes with recent versions of pybind11.
 .
 This is the first point from issue simgrid/simgrid#76.
Origin: upstream, https://framagit.org/simgrid/simgrid/-/commit/58f311658032f3dfc9085db60f6b7957323ef7a4

diff --git a/src/bindings/python/simgrid_python.cpp b/src/bindings/python/simgrid_python.cpp
index eac19eb65a9e3a2f967d16d6499b93d2194bda5c..78cb91cb988444a3ae7b536f7491ad33e4380bef 100644
--- a/src/bindings/python/simgrid_python.cpp
+++ b/src/bindings/python/simgrid_python.cpp
@@ -13,10 +13,28 @@
 #pragma GCC diagnostic ignored "-Wunused-value"
 #endif
 
-#include <pybind11/functional.h>
+#ifndef NDEBUG
+/* Many tests are failing after pybind11 commit ad6bf5cd39ca64b4a9bf846b84b11c4c8df1c8e1 "Adding PyGILState_Check() in
+ *  object_api<>::operator(). (#2919)".
+ * See https://github.com/pybind/pybind11/commit/ad6bf5cd39ca64b4a9bf846b84b11c4c8df1c8e1
+ *
+ * The failing tests are mostly those with boost/raw/sysv contexts. As a workaround, define NDEBUG before pybind11
+ * includes.
+ */
+#define NDEBUG
+#define NDEBUG_LOCALLY_DEFINED
+#endif
+
 #include <pybind11/pybind11.h> // Must come before our own stuff
+
+#include <pybind11/functional.h>
 #include <pybind11/stl.h>
 
+#ifdef NDEBUG_LOCALLY_DEFINED
+#undef NDEBUG_LOCALLY_DEFINED
+#undef NDEBUG
+#endif
+
 #if defined(__GNUG__)
 #pragma GCC diagnostic pop
 #endif
